All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
PEthSocket Class Reference

This class describes a type of socket that will communicate using raw ethernet packets. More...

`#include <ethsock.h>`

Inheritance diagram for PEthSocket:

## Classes

union | Address
| An ethernet MAC Address specification. More...
struct | Frame
| An ethernet MAC frame. More...

## Public Member Functions

Constructor
| PEthSocket (PINDEX nReadBuffers=8, PINDEX nWriteBuffers=1, PINDEX size=1514)
| Create a new ethernet packet socket. More...
| ~PEthSocket ()
| Close the socket. More...
Overrides from class PChannel
virtual PBoolean | Close ()
| Close the channel, shutting down the link to the data source. More...
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
Overrides from class PSocket
virtual PBoolean | Connect (const PString &address)
| Connect a socket to an interface. More...
virtual PBoolean | Listen (unsigned queueSize=5, WORD port=0, Reusability reuse=AddressIsExclusive)
| This function is illegal and will assert if attempted. More...
I/O functions
PBoolean | ResetAdaptor ()
| Reset the interface. More...
PBoolean | ReadPacket (PBYTEArray &buffer, Address &dest, Address &src, WORD &type, PINDEX &len, BYTE *&payload)
| Read a packet from the interface and parse out the information specified by the parameters. More...
Public Member Functions inherited from PSocket
PBoolean | Read (void *ptr, PINDEX len)
| Low level read from the channel. More...
| ~PSocket ()
PBoolean | SetOption (int option, int value, int level=SOL_SOCKET)
| Set options on the socket. More...
PBoolean | SetOption (int option, const void *valuePtr, PINDEX valueSize, int level=SOL_SOCKET)
| Set options on the socket. More...
PBoolean | GetOption (int option, int &value, int level=SOL_SOCKET)
| Get options on the socket. More...
PBoolean | GetOption (int option, void *valuePtr, PINDEX valueSize, int level=SOL_SOCKET)
| Get options on the socket. More...
virtual PBoolean | Accept (PSocket &socket)
| Open a socket to a remote host on the specified port number. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a socket. More...
virtual WORD | GetPortByService (const PString &service) const
| Get the port number for the specified service name. More...
virtual PString | GetServiceByPort (WORD port) const
| Get the service name from the port number. More...
void | SetPort (WORD port)
| Set the port number for the channel. More...
void | SetPort (const PString &service)
| Set the port number for the channel. More...
WORD | GetPort () const
| Get the port the TCP socket channel object instance is using. More...
PString | GetService () const
| Get a service name for the port number the TCP socket channel object instance is using. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two strings. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open. More...
virtual PString | GetName () const
| Get the platform and I/O channel type name of the channel. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
virtual PChannel * | GetBaseReadChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
virtual PChannel * | GetBaseWriteChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

virtual PBoolean | OpenSocket ()
virtual const char * | GetProtocolName () const
| This function returns the protocol name for the socket type. More...
Protected Member Functions inherited from PSocket
| PSocket ()
int | os_close ()
int | os_socket (int af, int type, int proto)
PBoolean | os_connect (struct sockaddr *sin, PINDEX size)
PBoolean | os_recvfrom (void *buf, PINDEX len, int flags, struct sockaddr *from, PINDEX *fromlen)
PBoolean | os_sendto (const void *buf, PINDEX len, int flags, struct sockaddr *to, PINDEX tolen)
PBoolean | os_accept (PSocket &listener, struct sockaddr *addr, PINDEX *size)
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

WORD | filterType
Address | macAddress
MediumTypes | medium
unsigned | filterMask
PBoolean | fakeMacHeader
PBoolean | ipppInterface
Protected Attributes inherited from PSocket
WORD | port
| Port to be used by the socket when opening the channel. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Information functions

enum | MediumTypes { MediumLoop, Medium802_3, MediumWan, MediumUnknown, NumMediumTypes }
| Medium types for the open interface. More...
PBoolean | EnumInterfaces (PINDEX idx, PString &name)
| Enumerate all the interfaces that are capable of being accessed at the ethernet level. More...
PBoolean | GetAddress (Address &addr)
| Get the low level MAC address of the open interface. More...
PBoolean | GetIpAddress (PIPSocket::Address &addr)
| Get the prime IP number bound to the open interface. More...
PBoolean | GetIpAddress (PIPSocket::Address &addr, PIPSocket::Address &netMask)
| Get the prime IP number bound to the open interface. More...
PBoolean | EnumIpAddress (PINDEX idx, PIPSocket::Address &addr, PIPSocket::Address &netMask)
| Enumerate all of the IP addresses and net masks bound to the open interface. More...
MediumTypes | GetMedium ()
| Return the type of the interface. More...

## Filtering functions

enum | EthTypes { TypeAll = 3, TypeIP = 0x800, TypeX25 = 0x805, TypeARP = 0x806, TypeAtalk = 0x809B, TypeAARP = 0x80F3, TypeIPX = 0x8137, TypeIPv6 = 0x86DD }
| Type codes for ethernet frames. More...
enum | FilterMask { FilterDirected = 0x01, FilterMulticast = 0x02, FilterAllMulticast = 0x04, FilterBroadcast = 0x08, FilterPromiscuous = 0x10 }
| Mask filter bits for GetFilter() function. More...
PBoolean | GetFilter (unsigned &mask, WORD &type)
| Get the current filtering criteria for receiving packets. More...
PBoolean | SetFilter (unsigned mask, WORD type=TypeAll)
| Set the current filtering criteria for receiving packets. More...

## Additional Inherited Members

Public Types inherited from PSocket
enum | Reusability { CanReuseAddress, AddressIsExclusive }
| Flags to reuse of port numbers in Listen() function. More...
Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PSocket
static int | Select (PSocket &sock1, PSocket &sock2)
| Select a socket with available data. More...
static int | Select (PSocket &sock1, PSocket &sock2, const PTimeInterval &timeout)
| Select a socket with available data. More...
static Errors | Select (SelectList &read)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, const PTimeInterval &timeout)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write, const PTimeInterval &timeout)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write, SelectList &except)
| Select a socket with available data. More...
static Errors | Select (SelectList &read, SelectList &write, SelectList &except, const PTimeInterval &timeout)
| Select a socket with available data. More...
static WORD | Host2Net (WORD v)
| Convert from host to network byte order. More...
static DWORD | Host2Net (DWORD v)
| Convert from host to network byte order. More...
static WORD | Net2Host (WORD v)
| Convert from network to host byte order. More...
static DWORD | Net2Host (DWORD v)
| Convert from network to host byte order. More...
static WORD | GetProtocolByName (const PString &name)
| Get the number of the protocol associated with the specified name. More...
static PString | GetNameByProtocol (WORD proto)
| Get the name of the protocol number specified. More...
static WORD | GetPortByService (const char *protocol, const PString &service)
| Get the port number for the specified service name. More...
static PString | GetServiceByPort (const char *protocol, WORD port)
| Get the service name from the port number. More...
Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...

## Detailed Description

This class describes a type of socket that will communicate using raw ethernet packets.

## Member Enumeration Documentation

enum PEthSocket::EthTypes

Type codes for ethernet frames.

Enumerator
TypeAll | All frames (3 is value for Linux)
TypeIP | Internet Protocol.
TypeX25 | X.25.
TypeARP | Address Resolution Protocol.
TypeAtalk | Appletalk DDP.
TypeAARP | Appletalk AARP.
TypeIPX | Novell IPX.
TypeIPv6 | Bluebook IPv6.

enum PEthSocket::FilterMask

Mask filter bits for GetFilter() function.

Enumerator
FilterDirected | Packets directed at the interface.
FilterMulticast | Multicast packets directed at the interface.
FilterAllMulticast | All multicast packets.
FilterBroadcast | Packets with a broadcast address.
FilterPromiscuous | All packets.

enum PEthSocket::MediumTypes

Medium types for the open interface.

Enumerator
MediumLoop | A Loopback Network.
Medium802_3 | An ethernet Network Interface Card (10base2, 10baseT etc)
MediumWan | A Wide Area Network (modem etc)
MediumUnknown | Something else.
NumMediumTypes |

## Constructor & Destructor Documentation

PEthSocket::PEthSocket | ( | PINDEX | nReadBuffers = `8`,
|  | PINDEX | nWriteBuffers = `1`,
|  | PINDEX | size = `1514`
| ) |  |

Create a new ethernet packet socket.

Some platforms require a set of buffers to be allocated to avoid losing frequent packets.

Parameters

  nReadBuffers | Number of buffers used for reading.
  nWriteBuffers | Number of buffers used for writing.
  size | Size of each buffer.

PEthSocket::~PEthSocket | ( |  | ) |

Close the socket.

## Member Function Documentation

virtual PBoolean PEthSocket::Close | ( |  | ) |

virtual

Close the channel, shutting down the link to the data source.

Returns
  true if the channel successfully closed.

Reimplemented from PChannel.

virtual PBoolean PEthSocket::Connect | ( | const PString & | address | ) |

virtual

Connect a socket to an interface.

The first form opens an interface by a name as returned by the EnumInterfaces() function. The second opens the interface that has the specified MAC address.

Returns
  true if the channel was successfully connected to the interface.

Parameters

  address | Name of interface to connect to.

Reimplemented from PSocket.

PBoolean PEthSocket::EnumInterfaces | ( | PINDEX | idx,
|  | PString & | name
| ) |  |

Enumerate all the interfaces that are capable of being accessed at the ethernet level.

Begin with index 0, and increment until the function returns false. The name string returned can be passed, unchanged, to the Connect() function.

Note that the driver does not need to be open for this function to work.

Returns
  true if an interface has the index supplied.

Parameters

  idx | Index of interface
  name | Interface name

PBoolean PEthSocket::EnumIpAddress | ( | PINDEX | idx,
|  | PIPSocket::Address & | addr,
|  | PIPSocket::Address & | netMask
| ) |  |

Enumerate all of the IP addresses and net masks bound to the open interface.

This allows all the addresses to be found on multi-homed hosts. Begin with index 0 and increment until the function returns false to enumerate all the addresses.

Returns
  true if the address is returned, false on error or if there are no more addresses bound to the interface.

Parameters

  idx | Index
  addr | Variable to receive the IP address.
  netMask | Variable to receive the net mask.

PBoolean PEthSocket::GetAddress | ( | Address & | addr | ) |

Get the low level MAC address of the open interface.

Returns
  true if the address is returned, false on error.

Parameters

  addr | Variable to receive the MAC address.

PBoolean PEthSocket::GetFilter | ( | unsigned & | mask,
|  | WORD & | type
| ) |  |

Get the current filtering criteria for receiving packets.

A bit-wise OR of the FilterMask values will filter packets so that they do not appear in the Read() function at all.

The type is be the specific frame type to accept. A value of TypeAll may be used to match all frame types.

Returns
  A bit mask is returned, a value of 0 indicates an error.

Parameters

  mask | Bits for filtering on address
  type | Code for filtering on type.

PBoolean PEthSocket::GetIpAddress | ( | PIPSocket::Address & | addr | ) |

Get the prime IP number bound to the open interface.

Returns
  true if the address is returned, false on error.

Parameters

  addr | Variable to receive the IP address.

PBoolean PEthSocket::GetIpAddress | ( | PIPSocket::Address & | addr,
|  | PIPSocket::Address & | netMask
| ) |  |

Get the prime IP number bound to the open interface.

This also returns the net mask associated with the open interface.

Returns
  true if the address is returned, false on error.

Parameters

  addr | Variable to receive the IP address.
  netMask | Variable to receive the net mask.

MediumTypes PEthSocket::GetMedium | ( |  | ) |

Return the type of the interface.

Returns
  Type enum for the interface, or NumMediumTypes if interface not open.

virtual const char* PEthSocket::GetProtocolName | ( |  | ) | const

protected virtual

This function returns the protocol name for the socket type.

Implements PSocket.

virtual PBoolean PEthSocket::Listen | ( | unsigned | queueSize = `5`,
|  | WORD | port = `0`,
|  | Reusability | reuse = `AddressIsExclusive`
| ) |  |

virtual

This function is illegal and will assert if attempted.

You must be connected to an interface using Connect() to do I/O on the socket.

Returns
  true if the channel was successfully opened.

Parameters

  queueSize | Number of pending accepts that may be queued.
  port | Port number to use for the connection.
  reuse | Can/Cant listen more than once.

Reimplemented from PSocket.

virtual PBoolean PEthSocket::OpenSocket | ( |  | ) |

protected virtual

Implements PSocket.

virtual PBoolean PEthSocket::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level read from the channel.

This function may block until the requested number of characters were read or the read timeout was reached. The GetLastReadCount() function returns the actual number of bytes read.

The GetErrorCode() function should be consulted after Read() returns false to determine what caused the failure.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Parameters

  buf | Pointer to a block of memory to receive the read bytes.
  len | Maximum number of bytes to read into the buffer.

Reimplemented from PChannel.

PBoolean PEthSocket::ReadPacket | ( | PBYTEArray & | buffer,
|  | Address & | dest,
|  | Address & | src,
|  | WORD & | type,
|  | PINDEX & | len,
|  | BYTE *& | payload
| ) |  |

Read a packet from the interface and parse out the information specified by the parameters.

This will automatically adjust for 802.2 and 802.3 ethernet frames.

Returns
  true if the packet read, false on error.

Parameters

  buffer | Buffer to receive the raw packet
  dest | Destination address of packet
  src | Source address of packet
  type | Packet frame type ID
  len | Length of payload
  payload | Pointer into `buffer` of payload.

PBoolean PEthSocket::ResetAdaptor | ( |  | ) |

Reset the interface.

PBoolean PEthSocket::SetFilter | ( | unsigned | mask,
|  | WORD | type = `TypeAll`
| ) |  |

Set the current filtering criteria for receiving packets.

A bit-wise OR of the FilterMask values will filter packets so that they do not appear in the Read() function at all.

The type is be the specific frame type to accept. A value of TypeAll may be used to match all frame types.

A value of zero for the filter mask is useless and will assert.

Returns
  true if the address is returned, false on error.

Parameters

  mask | Bits for filtering on address
  type | Code for filtering on type.

virtual PBoolean PEthSocket::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |

virtual

Low level write to the channel.

This function will block until the requested number of characters are written or the write timeout is reached. The GetLastWriteCount() function returns the actual number of bytes written.

The GetErrorCode() function should be consulted after Write() returns false to determine what caused the failure.

Returns
  true if at least len bytes were written to the channel.

Parameters

  buf | Pointer to a block of memory to write.
  len | Number of bytes to write.

Reimplemented from PChannel.

## Member Data Documentation

PBoolean PEthSocket::fakeMacHeader

protected

unsigned PEthSocket::filterMask

protected

WORD PEthSocket::filterType

protected

PBoolean PEthSocket::ipppInterface

protected

Address PEthSocket::macAddress

protected

MediumTypes PEthSocket::medium

protected

The documentation for this class was generated from the following file:

- ethsock.h